USE MASTER
GO

DROP DATABASE TEST
GO

CREATE DATABASE TEST
GO

USE TEST
GO

CREATE TABLE [Customers](
	[CustomerID] [int] IDENTITY NOT NULL,
	[FirstName] [varchar](50) NOT NULL,
	[LastName] [varchar](50) NOT NULL,
	[AccountBalance] [float] NOT NULL
,
 CONSTRAINT [PK_Customers] PRIMARY KEY CLUSTERED 
(
	[CustomerID] ASC
) ON [PRIMARY]
) ON [PRIMARY]
GO

CREATE TABLE [Products](
	[ProductID] [int] IDENTITY NOT NULL,
	[ProductName] [varchar](50) NOT NULL,
	[ProductPrice] [float] NOT NULL,
 CONSTRAINT [PK_Products] PRIMARY KEY CLUSTERED 
(
	[ProductID] ASC
) ON [PRIMARY]
) ON [PRIMARY]
GO

CREATE TABLE [CustomerProduct](
	[CustomerProduct] [int] IDENTITY NOT NULL,
	[CustomerID] [int] REFERENCES CUSTOMERS NOT NULL,
	[ProductID] [int] REFERENCES PRODUCTS NOT NULL,
    CONSTRAINT [PK_CustomerProduct] PRIMARY KEY CLUSTERED 
(
	[CustomerProduct] ASC
) ON [PRIMARY]
) ON [PRIMARY]
GO

INSERT INTO CUSTOMERS (FIRSTNAME, LASTNAME, ACCOUNTBALANCE) VALUES ('Capt.', 'Kirk', 100)
INSERT INTO CUSTOMERS (FIRSTNAME, LASTNAME, ACCOUNTBALANCE) VALUES ('Super', 'Man', 100)

INSERT INTO PRODUCTS (PRODUCTNAME, PRODUCTPRICE) VALUES ('Cape',4)
INSERT INTO PRODUCTS (PRODUCTNAME, PRODUCTPRICE) VALUES ('Phasor Gun',9)

